{% load gestion_projets_extras %}

<div class="remark primary">
    <p><b>Explication :</b> En tant qu'étudiant, vous devez choisir un sujet et constituer un groupe de 3 à 4 personnes.</p>
    <p><b>Contrainte :</b> Vous ne pouvez choisir qu'un seul groupe.</p>
    <p><b>Tâches :</b><br> 1/ Créer ou rejoindre un groupe<br> 2/ Classer les sujets par ordre de préférence (décroissant)<br> 3/ Un problème : contacter le responsable des projets </p>
</div>

<div class="m-3">
    <div class="grid">
        <div class="row">
            <div class="cell-lg-6">

                {% if  session.maximum_per_group > 1 %}

                    <a class="image-button warning" title="Créer un nouveau groupe seulement si vous ne faites partie d'aucun groupe" href="{% url 'gestion_projets:create_group_selection' session.id %}"><center>
                        <span class="mif-file-text icon"></span>
                        <span class="caption">Créer un groupe</span></center>
                    </a>

                    <!-- Liste des sujets -->
                    <table class="table">
                        <thead>
                        <tr>
                            <th>Liste des groupes</th>
                            <th>Nombre</th>
                            <th>Action</th>
                        </tr>
                        </thead>
                        <tbody>
                        {% for group in group_list.all %}
                            <tr >
                                <td>{% for user_group in group.users.all %}{{ user_group.first_name }} {{ user_group.last_name }}  {% endfor %}</td>

                                <td> 
                                    {{ group.users.count }} / {{ session.maximum_per_group }}
                                </td>
                                <td> 
                                    {% if  group.users.count < session.maximum_per_group %}
                                    <a class="image-button success" title="Rejoindre ce groupe" href="{% url 'gestion_projets:join_group_selection' session.id group.id %}"><center>
                                        <span class="mif-file-text icon"></span>
                                        <span class="caption">Rejoindre</span></center>
                                    </a>
                                    {% endif %}

                                    <a class="image-button error" title="Quitter ce groupe" href="{% url 'gestion_projets:quit_group_selection' session.id group.id %}"><center>
                                        <span class="mif-file-text icon"></span>
                                        <span class="caption">Quitter</span></center>
                                    </a>
                                </td>
                            </tr>
                        {% endfor %}
                        </tbody>
                    </table>
            </div>
            <div class="cell-lg-6">
                {% endif %}
                <!-- Affichage du projet courant -->
                {% if projectSelection_user.count == 0 %}
                    <div class="remark warning"><p>Choisir ou créer un groupe afin de pouvoir classer vos sujets</p></div>
                {% else %}

                    {% if projectSelection_user.count > 1 %}
                        <div class="remark warning">Erreur : Nombre de projets sélectionnés trop important</div>
                    {% endif %}

                    <div class="remark warning">Classer vos sujets par préférence en ordre décroissant (1er choix en haut, dernier choix en bas).</div>
     
                    <style>
                        #sortable { list-style-type: none; margin: 0; padding: 0; width: 100%; }
                        #sortable li { margin: 0 5px 5px 5px; padding: 5px; font-size: 1.2em; }
                        .ui-state-default {background-color:#efefef;}
                        .ui-state-highlight {background-color:#1ba1e2;height:2.5em}
                    </style>


                    {% for project in projectSelection_user %}
                        {% if session.enable_ordering %}
                        <script src="https://code.jquery.com/ui/1.12.1/jquery-ui.js"></script>
                        <script>
                            $( function() {
                            $( "#sortable" ).sortable({
                              placeholder: "ui-state-highlight"
                            });
                            $( "#sortable" ).disableSelection();
                            } );
                        </script>
                        {% endif %}
                        <div id="message_order"></div>
                        <ul id="sortable">
                            {% for subject in session.subjects.all %}
                                <li id="{{ subject.id }}" class="ui-state-default">
                                    <table  style="width:100%">
                                        <tr>
                                            <td  width="5%"><span class="icon mif-pan-tool"></td>
                                            <td  width="60%">{{ subject.title }}</td>
                                            <td  width="25%">{{ subject.user.first_name }} {{ subject.user.last_name }}</td>
                                            <td  width="10%" style="text-align:right">
                                                <a class="image-button success" title="Voir en détail le sujet" target="_blank" href="{% url 'gestion_projets:subject_view' subject.id %}"><center>
                                                    <span class="mif-file-text icon"></span>
                                                    <span class="caption">Voir</span></center>
                                                </a>
                                            </td>
                                        </tr>
                                    </table>
                                </li>
                            {% endfor %}
                        </ul>

                        <!-- Script to load the saved order -->
                        {% if project.order != '' and session.enable_ordering %}
                            <script type="text/javascript">

                                $("#sortable").sortable({
                                    cancel: ".fixed"
                                });
                                $("#sortable").disableSelection();

                                var savedOrd = '{{ project.order }}';
                                if (savedOrd) {
                                    $.each(savedOrd.split(','), function (i, e) {
                                        $('#' + e).insertAfter('#sortable>li:eq(' + i + ')');
                                    });
                                }

                            </script>

                        <!-- Button to save Order -->
                        <button class="image-button warning" title="Choisir ce sujet" onclick='saveOrder();'>
                            <span class="mif-arrow-right icon"></span>
                            <span class="caption">Sauvegarder l'ordre</span></center>
                        </button>
                        {% endif %}

                        <!-- Script to save Order -->
                        <script type="text/javascript">
                            $(function () {
                                $.ajaxSetup({
                                    headers: { "X-CSRFToken": getCookie("csrftoken") }
                                });
                            });
                            function getCookie(c_name)
                            {
                                if (document.cookie.length > 0)
                                {
                                    c_start = document.cookie.indexOf(c_name + "=");
                                    if (c_start != -1)
                                    {
                                        c_start = c_start + c_name.length + 1;
                                        c_end = document.cookie.indexOf(";", c_start);
                                        if (c_end == -1) c_end = document.cookie.length;
                                        return unescape(document.cookie.substring(c_start,c_end));
                                    }
                                }
                                return "";
                            }

                            function saveOrder() {
                                var result = $('#sortable').sortable("toArray");

                                $.ajax({
                                        type: 'POST',
                                        url: "{% url 'gestion_projets:save_group_selection' session.id project.id %}",
                                        data: 'order=' + result,
                                        success: function(data) {
                                            $('#message_order').text("L'ordre a bien été sauvegardé");
                                        },
                                        error: function(resultat, status, erreur) {
                                            $('#message_order').text("Attention votre ordre n'a pas été sauvegardé");
                                        }
                                    });
                            }
                        </script>
                    {% endfor %}
                {% endif %}
            </div>
        </div>
    </div>
</div>

